#!/usr/bin/python
# -*- coding:Utf-8 -*
print "Content-Type: text/html\n\n"

import cgi
import cgitb; cgitb.enable(display=1, logdir='/tmp')
import commands
import os, urllib, subprocess as sub
import re
import sys
import time
from xml.dom import minidom

sys.stderr = sys.stdout

__version__ = '1.0a'
UUID = os.system('cat /proc/sys/kernel/random/uuid')

def appz(p):
	home = '/usr/karotz/apps'
	curdir = ''; appz = ''; nb = 0;
	for root, dirs, files in os.walk(home):
		for filename in files:
			if filename == 'descriptor.xml':
				# print 'File: ', root, filename
				xml = os.path.join(root, filename)
				if os.access(xml, os.R_OK):
					try:
						dom = minidom.parse(xml)
						typ = 'hosted'
						try: typ = dom.getElementsByTagName('deployment')[0].childNodes[0].data
						except: pass
						title = dom.getElementsByTagName('name')[0].childNodes[0].data.decode('utf-8')
						nb += 1
						if nb%6 == 0:
							appz += '<br />'
							nb = 0
						if typ == 'hosted':
							appz += '<button class="appz btn btn-info" id="'+os.path.basename(root)+'">'+title+'</button> '
						else:
							url = dom.getElementsByTagName('callback')[0].childNodes[0].data
							appz += '<a href="'+url+'" class="btn" target="WebApp">'+title+'</a> '
					except: pass
	return appz

def v_rootfs(p):
	file = '/etc/conf/rootfs_version'
	if not os.path.exists(file): return 'cannot find file /etc/conf/rootfs_version'
	rootfs_file = open(file)
	version = rootfs_file.read().strip()
	rootfs_file.close()
	return version

def v_sys(p):
	file = '/etc/conf/sys_version'
	if not os.path.exists(file): return 'cannot find file /etc/conf/sys_version'
	sys_file = open(file)
	version = sys_file.read().strip()
	sys_file.close()
	return version

def version(p):
	return 'ver. '+__version__

def g_ipp(p):
	params = urllib.urlencode({'p1': 1, 'p2': 2})
	f = urllib.urlopen('http://checkip.dyndns.org/?%s' % params)
	# Post : f = urllib.urlopen('http://checkip.dyndns.org/', params)
	s = f.read()
	m = re.search('([\d]*\.[\d]*\.[\d]*\.[\d]*)', s)
	return m.group(0)
def g_cpuinfo(p):
    return g_cat('/proc/cpuinfo')
def g_devinfo(p):
	return g_cat('/proc/devices')
def g_meminfo(p):
	return g_cat('/proc/meminfo')
def g_partinfo(p):
	return g_cat('/proc/partitions')
def g_cat(p):
	res = ''
	try:
		f = os.popen('cat '+p)
		for line in f.readlines(): res = res + line;
		f.close()
		return res
	except: return 'error'
def g_time(p):
	return 'Karotz <span class="label label-info">datetime</span> : '+time.ctime()

def s_led(p):
	os.system('killall led > /dev/null')
	cmd = 'dbus-send --system --dest=com.mindscape.karotz.Led /com/mindscape/karotz/Led com.mindscape.karotz.KarotzInterface.light string:'+str(UUID)+' string:0000FF'
	os.system(cmd)
	return 'OK.'

def reboot(p):
	os.system('(sleep 3; /sbin/reboot) &')
	return '<span class="label label-important">Rebooting now...</span>'

cmdTab = {
	'appz':appz,
	'cpu':g_cpuinfo,
	'dev':g_devinfo,
	'ipp':g_ipp,
	'led':s_led,
	'mem':g_meminfo,
	'part':g_partinfo,
	'reboot':reboot,
	'time':g_time,
	'v_rootfs':v_rootfs,
	'v_sys':v_sys,
	'version':version
}

def main():
	form = cgi.FieldStorage()
	cmd = cgi.escape(form.getvalue('cmd', 'time'))
	param = cgi.escape(form.getvalue('p', ''))

	res  = 'No way.'
	if cmd in cmdTab: res = cmdTab[cmd](param)
	print res

if __name__ == '__main__': main()
